// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/VamParameters.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAM_PARAMETERS__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAM_PARAMETERS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'basic_container'
#include "etsi_its_vam_ts_msgs/msg/detail/basic_container__struct.h"
// Member 'vru_high_frequency_container'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_high_frequency_container__struct.h"
// Member 'vru_low_frequency_container'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_low_frequency_container__struct.h"
// Member 'vru_cluster_information_container'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_cluster_information_container__struct.h"
// Member 'vru_cluster_operation_container'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_cluster_operation_container__struct.h"
// Member 'vru_motion_prediction_container'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_motion_prediction_container__struct.h"

/// Struct defined in msg/VamParameters in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__VamParameters
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
  ///   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   vam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * @details VamParameters
  ///  * The VAM payload includes the @ref BasicContainer and @ref VruHighFrequencyContainer.
  ///  * The VAM payload may also include additional containers: @ref VruLowFrequencyContainer,
  ///  * @ref VruClusterInformationContainer, @ref VruClusterOperationContainer and @ref VruMotionPredictionContainer.
  ///  * The selection of the additional containers depends on the dissemination criteria,
  ///  * e.g. _vruCluster_ or _MotionDynamicPrediction_ availability.
  ///  *
  ///  * @category: Communication information
  ///  * @revision: V2.2.1
  /// **/
  ///     VamParameters ::= SEQUENCE {
  ///         basicContainer                 BasicContainer,
  ///         vruHighFrequencyContainer      VruHighFrequencyContainer,
  ///         vruLowFrequencyContainer       VruLowFrequencyContainer OPTIONAL,
  ///         vruClusterInformationContainer VruClusterInformationContainer OPTIONAL,
  ///         vruClusterOperationContainer   VruClusterOperationContainer OPTIONAL,
  ///         vruMotionPredictionContainer   VruMotionPredictionContainer OPTIONAL,
  ///         ...
  ///     }
  /// ------------------------------------------------------------------------------
  etsi_its_vam_ts_msgs__msg__BasicContainer basic_container;
  etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer vru_high_frequency_container;
  etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer vru_low_frequency_container;
  bool vru_low_frequency_container_is_present;
  etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer vru_cluster_information_container;
  bool vru_cluster_information_container_is_present;
  etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer vru_cluster_operation_container;
  bool vru_cluster_operation_container_is_present;
  etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer vru_motion_prediction_container;
  bool vru_motion_prediction_container_is_present;
} etsi_its_vam_ts_msgs__msg__VamParameters;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__VamParameters.
typedef struct etsi_its_vam_ts_msgs__msg__VamParameters__Sequence
{
  etsi_its_vam_ts_msgs__msg__VamParameters * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__VamParameters__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAM_PARAMETERS__STRUCT_H_
